clear all;

A=10;
La=0.1; %[H]
Ra=10;  %[ohm]
kt=0.25; %[Nw m/A]
kw=0.2;  %[V seg/rad]
N1=1;
N2=20;
P=1e-2; %[m/rad]
K=5000; %[Nw/m]
B1=1e-3; %[Nw m seg/rad]
J=2e-3; %[Nw m seg^2 /rad]
B2=5; %[Nw m seg/rad]
Rov=600; %[seg/m2]
R1=1000; % seg/m2
R2=2500; % seg/m2
A1=12; % m2 
A2=1.2; % m2 
Ks=563; %[V seg/m3]

% Punto de equilibrio

Vr=0.5; %[V]
qi=2.7e-3; %[m3/seg]

% Polos del sistema hidraulico

% a2=R1*A1*A2*R2*Rv/(R1+R2+Rv);
% a1=(R1*(A1*R2+A2*Rv)+A1*R2*Rv+A2*R2*Rv)/(R1+R2+Rv);
% k1=R2/(R1+R2+Rv)

polo=2*pi*1000;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Modelo linealizado

Vr_o=Vr;
qi_o=qi;

% Determinacion del punto de equilibrio:
y_o=0.01

%Ia_o=(Vr-(Ks*h2_o*(y_o^0.5)/Rov))*A/Ra
%Ia_o*kt=(N1*P/N2)*K*y_o

Rv_o=Rov/(y_o^0.5);
h1_o=qi*R2*(R1+Rv_o)/(R2+R1+Rv_o)
h2_o=h1_o*Rv_o/(R1+Rv_o)

w_o=0
Ia_o=(Vr-(Ks*h2_o*(y_o^0.5)/Rov))*A/Ra

% 
% 
% h1_o=4.9737;
% h2_o=4.2632;
% Ia_o=0.1;
% w_o=0;
% y_o=0.01;

% Coeficientes de las matrices linealizadas

a11=-(1/A1)*((1/R1)+(1/R2));
a12=1/(A1*R1);
a13=0;a14=0;a15=0;

a21=1/(A1*R2);
a22=-(Rov+R1*(y_o)^0.5)/(A2*Rov*R1);
a23=0;a24=0;
a25=-h2_o*R1/(A2*Rov*R1*2*(y_o)^0.5);

a31=0;
a32=-(Ks*A*(y_o)^0.5)/(Rov*La);
a33=-Ra/La;
a34=-kw/La;
a35=-(Ks*A*h2_o)/(Rov*La*2*(y_o)^0.5);

a41=0;a42=0;
a43=kt/J;
a44=-(B2*(N1*P/N2)^2+B1)*(1/J);
a45=-(N1*P*K/(N2*J));


a51=0;a52=0;a53=0;a54=(N1/N2)*P;a55=0;

b11=1/A1;
b12=0;
b21=0;b22=0;
b31=0;b32=A/La;
b41=0;b42=0;
b51=0;b52=0;



A_lin=[-1.16e-4 8.3e-5 0 0 0; 8.3e-4 -9.72e-4 0 0 -0.033; 0 -0.938 -100 -2 -22.33; 0 0 125 -0.5 -1250; 0 0 0 5e-4 0];
B_lin=[0.083 0;0 0; 0 100; 0 0;0 0];
C_lin=eye(5);
D_lin=zeros(5,2);

A_lin2=[a11 a12 a13 a14 a15; a21 a22 a23 a24 a25; a31 a32 a33 a34 a35; a41 a42 a43 a44 a45;a51 a52 a53 a54 a55];
B_lin2=[b11 b12;b21 b22; b31 b32; b41 b42;b51 b52];
C_lin2=eye(5);
D_lin2=zeros(5,2);




% % Nuevo punto de operacin
% % Vr=4*Vr
% % Qi=2*Qi
% 
% h1_o=7.67;
% h2_o=5.34;
% Ia_o=0.69;
% w_o=0;
% y_o=0.0687;
% 
% 
% % Nuevo punto de operacin
% % Vr=10*Vr
% % Qi=10*Qi
% 
% h1_o=46.125;
% h2_o=37.575;
% Ia_o=0.1865;
% w_o=0;
% y_o=0.0185;


% Nuevo punto de operacin
% Vr=4*Vr
% Qi=0.1*Qi

% h1_o=0.3284;
% h2_o=0.19;
% Ia_o=1.92;
% w_o=0;
% y_o=0.1922;
% 
% % Nuevo punto de operacin
% Vr=0.1*Vr
% qi=10*qi
% 
% h1_o=67.278;
% h2_o=67.2;
% Ia_o=0;
% w_o=0;
% y_o=0.65e-6;
% 
% Vr_o=Vr;
% qi_o=qi;

t_sim1=390000;
t_sim2=790000;
t_sim3=1590000;

ref=Vr;
%ref=1.001*Vr;
%ref=1.5*Vr;