clear all;

Rov=600; %[seg/m2]
R1=1000; % seg/m2
R2=2500; % seg/m2
A1=12; % m2 
A2=1.2; % m2 

y=1e-3:1e-3:0.1;
Rv=Rov*(y.^(-0.5));

Ganancia=R2*(R1+R2+Rv).^(-1);
figure(1)
plot(y,Rv)

figure(2)
plot(y,Ganancia,'r')


% Maxima ganancia: y aprox 1e-3
% Minima ganancia: y aprox 90e-3
ymin=1e-3;
ymax=90e-3;

Rvmax=3*600*(ymin^(-0.5))
Rvmin=600*(ymax^(-0.5))

% Transferencia para Rvmax

a2=R1*A1*A2*R2*Rvmax/(R1+R2+Rvmax);
a1=(R1*(A1*R2+A2*Rvmax)+A1*R2*Rvmax+A2*R2*Rvmax)/(R1+R2+Rvmax);
k1=R2/(R1+R2+Rvmax);

G1=k1*tf([1],[a2 a1 1]);
zpk(G1)

figure(3)
bode(G1)

% Transferencia para Rvmin

a2=R1*A1*A2*R2*Rvmin/(R1+R2+Rvmin);
a1=(R1*(A1*R2+A2*Rvmin)+A1*R2*Rvmin+A2*R2*Rvmin)/(R1+R2+Rvmin);
k2=R2/(R1+R2+Rvmin);

G2=k2*tf([1],[a2 a1 1]);
zpk(G2)

hold on
bode(G2)

% Ganancia=R2/(R1+R2+Rv)